#!/usr/bin/env python
#Author: Mark Feineigle
#Create Date: 2018/02/04
#Last Modify: 2018/02/04
# Miller-Rabin algorithm to probabilistically determine prime numbers
# (2017)_Stallings_-_Cryptography_and_network_security_principles_and_practice.pdf
# page 69

#import numpy as np
import sys

def mr_prime(n, k, q, a):
  if a**q % n == 1:
    return False #"inconclusive"
  for j in range(k):
    if a**(q*2**j) % n == n-1:
      return False #"inconclusive"
  return True #"composite"

if __name__ == "__main__":
  TESTS = 0
  count = 0

  #n = 221
  #k = 2
  #q = 55
  n = 29
  k = 2
  q = 7
  
  for a in range(2,n):
    count += 1
    if mr_prime(n=n, k=k, q=q, a=a):
      print "{} is NOT a probable prime ({} tests)".format(n, count)
      sys.exit()
    if (TESTS != 0 and count == TESTS) or (count == n-2):
      print "{} IS a probable prime ({} tests)".format(n, count)
      sys.exit()
